//
// Generated by JTB 1.2.2
//

package visitor;
import syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
public class ObjectDepthFirst implements ObjectVisitor {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public Object visit(NodeList n, Object argu) {
      Object _ret=null;
      int _count=0;
      for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
         ((Node)e.nextElement()).accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public Object visit(NodeListOptional n, Object argu) {
      if ( n.present() ) {
         Object _ret=null;
         int _count=0;
         for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
            ((Node)e.nextElement()).accept(this,argu);
            _count++;
         }
         return _ret;
      }
      else
         return null;
   }

   public Object visit(NodeOptional n, Object argu) {
      if ( n.present() )
         return n.node.accept(this,argu);
      else
         return null;
   }

   public Object visit(NodeSequence n, Object argu) {
      Object _ret=null;
      int _count=0;
      for ( Enumeration e = n.elements(); e.hasMoreElements(); ) {
         ((Node)e.nextElement()).accept(this,argu);
         _count++;
      }
      return _ret;
   }

   public Object visit(NodeToken n, Object argu) { return null; }

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> ( statement() )*
    * f1 -> <END>
    */
   public Object visit(label n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> assignment_stmt()
    *       | pointer_stmt()
    *       | object_stmt()
    *       | group_stmt()
    */
   public Object visit(statement n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> attribute_identifier()
    * f1 -> <EQUAL_SIGN>
    * f2 -> value()
    */
   public Object visit(assignment_stmt n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <ID>
    */
   public Object visit(attribute_identifier n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <LETTER>
    *       | <ID>
    */
   public Object visit(identifier n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <BEGIN_OB>
    * f1 -> <EQUAL_SIGN>
    * f2 -> object_identifier()
    * f3 -> ( statement() )*
    * f4 -> <END_OB>
    * f5 -> ( <EQUAL_SIGN> object_identifier() )?
    */
   public Object visit(object_stmt n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <ID>
    */
   public Object visit(object_identifier n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <BEGIN_GR>
    * f1 -> <EQUAL_SIGN>
    * f2 -> group_identifier()
    * f3 -> ( statement() )*
    * f4 -> <END_GR>
    * f5 -> ( <EQUAL_SIGN> group_identifier() )?
    */
   public Object visit(group_stmt n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      n.f5.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <ID>
    */
   public Object visit(group_identifier n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <POINTER>
    * f1 -> object_identifier()
    * f2 -> <EQUAL_SIGN>
    * f3 -> value()
    */
   public Object visit(pointer_stmt n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> sequence_value()
    *       | scalar_value()
    *       | set_value()
    */
   public Object visit(value n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> numeric_value()
    *       | symbolic_value()
    *       | text_string_value()
    *       | date_time_value()
    */
   public Object visit(scalar_value n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> numeric_option()
    *       | numeric_option() units_expression()
    */
   public Object visit(numeric_value n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> integer()
    *       | based_integer()
    *       | <FLOATING_POINT_LITERAL>
    */
   public Object visit(numeric_option n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> units_factor()
    * f1 -> ( mult_op() units_factor() )*
    */
   public Object visit(units_expression n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <MULTIPLICATION_DIVISION_SIGN>
    */
   public Object visit(mult_op n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> units_identifier()
    *       | units_identifier() exp_op() integer()
    */
   public Object visit(units_factor n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <ID>
    */
   public Object visit(units_identifier n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <EXPONENT_SIGN>
    */
   public Object visit(exp_op n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> time()
    *       | date() ( <TIME_CONSTANT> time() )*
    *       | <DATE_TIME>
    */
   public Object visit(date_time_value n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> quoted_text()
    */
   public Object visit(text_string_value n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> identifier()
    *       | quoted_symbol()
    */
   public Object visit(symbolic_value n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> sequence_1D()
    *       | sequence_2D()
    */
   public Object visit(sequence_value n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <LEFT_PARAN>
    * f1 -> scalar_value()
    * f2 -> ( <COMMA> scalar_value() )*
    * f3 -> <RIGHT_PARAN>
    */
   public Object visit(sequence_1D n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <LEFT_PARAN>
    * f1 -> ( sequence_1D() )+
    * f2 -> <RIGHT_PARAN>
    */
   public Object visit(sequence_2D n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <LEFT_BRACE>
    * f1 -> scalar_value()
    * f2 -> ( <COMMA> scalar_value() )*
    * f3 -> <RIGHT_BRACE>
    */
   public Object visit(set_value n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer()
    *       | <SIGNED_INTEGER>
    */
   public Object visit(integer n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <PLUS_MINUS_SIGN>
    */
   public Object visit(sign n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( <DIGIT> )+
    */
   public Object visit(unsigned_integer n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <DIGIT>
    */
   public Object visit(digit n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> radix() <HASH_SIGN> ( extended_digit() )+ <HASH_SIGN>
    *       | radix() <HASH_SIGN> sign() ( extended_digit() )+ <HASH_SIGN>
    */
   public Object visit(based_integer n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> digit()
    *       | letter()
    */
   public Object visit(extended_digit n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <LETTER>
    */
   public Object visit(letter n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer()
    */
   public Object visit(radix n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> ( sign() )? unscaled_real()
    *       | ( sign() )? scaled_real()
    */
   public Object visit(real n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer() <DOT_SIGN> unsigned_integer()
    *       | unsigned_integer() <DOT_SIGN>
    *       | <DOT_SIGN> unsigned_integer()
    */
   public Object visit(unscaled_real n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unscaled_real()
    * f1 -> exponent()
    */
   public Object visit(scaled_real n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <EXP_E_C> integer()
    *       | <EXP_E_L> integer()
    */
   public Object visit(exponent n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> year_day()
    */
   public Object visit(date n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <YEAR_DAY>
    */
   public Object visit(year_day n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> year()
    * f1 -> <MINUS_SIGN>
    * f2 -> month()
    * f3 -> <MINUS_SIGN>
    * f4 -> day()
    */
   public Object visit(year_month_day n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      n.f3.accept(this, argu);
      n.f4.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer()
    */
   public Object visit(year n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer()
    */
   public Object visit(month n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer()
    */
   public Object visit(day n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> hour_min_sec() ( <Z_SIGN> )?
    *       | zoned_time()
    */
   public Object visit(time n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> hour_min_sec()
    */
   public Object visit(local_time n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> hour_min_sec()
    * f1 -> <Z_SIGN>
    */
   public Object visit(utc_time n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> hour_min_sec()
    * f1 -> zone_offset()
    */
   public Object visit(zoned_time n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <HOUR_MIN>
    */
   public Object visit(hour_min_sec n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer()
    */
   public Object visit(hour n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer()
    */
   public Object visit(minute n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> unsigned_integer()
    *       | unscaled_real()
    */
   public Object visit(second n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> sign()
    * f1 -> hour()
    * f2 -> ( <COLON_SIGN> minute() )?
    */
   public Object visit(zone_offset n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> date()
    * f1 -> <TIME_CONSTANT>
    * f2 -> time()
    */
   public Object visit(date_time n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <QUOTED_STRING>
    */
   public Object visit(quoted_text n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <SQUOTE_SIGN>
    * f1 -> ( character() )*
    * f2 -> <SQUOTE_SIGN>
    */
   public Object visit(quoted_symbol n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      n.f1.accept(this, argu);
      n.f2.accept(this, argu);
      return _ret;
   }

   /**
    * f0 -> <LETTER>
    *       | <DIGIT>
    *       | <SPECIAL_CHARACTER>
    *       | <SPACING_CHARACTER>
    *       | <FORMAT_EFFECTOR>
    *       | <OTHER_CHARACTER>
    */
   public Object visit(character n, Object argu) {
      Object _ret=null;
      n.f0.accept(this, argu);
      return _ret;
   }

}
