//
// Generated by JTB 1.2.2
//

package visitor;
import syntaxtree.*;
import java.util.*;

/**
 * All void visitors must implement this interface.
 */
public interface Visitor {
   //
   // void Auto class visitors
   //
   public void visit(NodeList n);
   public void visit(NodeListOptional n);
   public void visit(NodeOptional n);
   public void visit(NodeSequence n);
   public void visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> ( statement() )*
    * f1 -> <END>
    */
   public void visit(label n);

   /**
    * f0 -> assignment_stmt()
    *       | pointer_stmt()
    *       | object_stmt()
    *       | group_stmt()
    */
   public void visit(statement n);

   /**
    * f0 -> attribute_identifier()
    * f1 -> <EQUAL_SIGN>
    * f2 -> value()
    */
   public void visit(assignment_stmt n);

   /**
    * f0 -> <ID>
    */
   public void visit(attribute_identifier n);

   /**
    * f0 -> <LETTER>
    *       | <ID>
    */
   public void visit(identifier n);

   /**
    * f0 -> <BEGIN_OB>
    * f1 -> <EQUAL_SIGN>
    * f2 -> object_identifier()
    * f3 -> ( statement() )*
    * f4 -> <END_OB>
    * f5 -> ( <EQUAL_SIGN> object_identifier() )?
    */
   public void visit(object_stmt n);

   /**
    * f0 -> <ID>
    */
   public void visit(object_identifier n);

   /**
    * f0 -> <BEGIN_GR>
    * f1 -> <EQUAL_SIGN>
    * f2 -> group_identifier()
    * f3 -> ( statement() )*
    * f4 -> <END_GR>
    * f5 -> ( <EQUAL_SIGN> group_identifier() )?
    */
   public void visit(group_stmt n);

   /**
    * f0 -> <ID>
    */
   public void visit(group_identifier n);

   /**
    * f0 -> <POINTER>
    * f1 -> object_identifier()
    * f2 -> <EQUAL_SIGN>
    * f3 -> value()
    */
   public void visit(pointer_stmt n);

   /**
    * f0 -> sequence_value()
    *       | scalar_value()
    *       | set_value()
    */
   public void visit(value n);

   /**
    * f0 -> numeric_value()
    *       | symbolic_value()
    *       | text_string_value()
    *       | date_time_value()
    */
   public void visit(scalar_value n);

   /**
    * f0 -> numeric_option()
    *       | numeric_option() units_expression()
    */
   public void visit(numeric_value n);

   /**
    * f0 -> integer()
    *       | based_integer()
    *       | <FLOATING_POINT_LITERAL>
    */
   public void visit(numeric_option n);

   /**
    * f0 -> units_factor()
    * f1 -> ( mult_op() units_factor() )*
    */
   public void visit(units_expression n);

   /**
    * f0 -> <MULTIPLICATION_DIVISION_SIGN>
    */
   public void visit(mult_op n);

   /**
    * f0 -> units_identifier()
    *       | units_identifier() exp_op() integer()
    */
   public void visit(units_factor n);

   /**
    * f0 -> <ID>
    */
   public void visit(units_identifier n);

   /**
    * f0 -> <EXPONENT_SIGN>
    */
   public void visit(exp_op n);

   /**
    * f0 -> time()
    *       | date() ( <TIME_CONSTANT> time() )*
    *       | <DATE_TIME>
    */
   public void visit(date_time_value n);

   /**
    * f0 -> quoted_text()
    */
   public void visit(text_string_value n);

   /**
    * f0 -> identifier()
    *       | quoted_symbol()
    */
   public void visit(symbolic_value n);

   /**
    * f0 -> sequence_1D()
    *       | sequence_2D()
    */
   public void visit(sequence_value n);

   /**
    * f0 -> <LEFT_PARAN>
    * f1 -> scalar_value()
    * f2 -> ( <COMMA> scalar_value() )*
    * f3 -> <RIGHT_PARAN>
    */
   public void visit(sequence_1D n);

   /**
    * f0 -> <LEFT_PARAN>
    * f1 -> ( sequence_1D() )+
    * f2 -> <RIGHT_PARAN>
    */
   public void visit(sequence_2D n);

   /**
    * f0 -> <LEFT_BRACE>
    * f1 -> scalar_value()
    * f2 -> ( <COMMA> scalar_value() )*
    * f3 -> <RIGHT_BRACE>
    */
   public void visit(set_value n);

   /**
    * f0 -> unsigned_integer()
    *       | <SIGNED_INTEGER>
    */
   public void visit(integer n);

   /**
    * f0 -> <PLUS_MINUS_SIGN>
    */
   public void visit(sign n);

   /**
    * f0 -> ( <DIGIT> )+
    */
   public void visit(unsigned_integer n);

   /**
    * f0 -> <DIGIT>
    */
   public void visit(digit n);

   /**
    * f0 -> radix() <HASH_SIGN> ( extended_digit() )+ <HASH_SIGN>
    *       | radix() <HASH_SIGN> sign() ( extended_digit() )+ <HASH_SIGN>
    */
   public void visit(based_integer n);

   /**
    * f0 -> digit()
    *       | letter()
    */
   public void visit(extended_digit n);

   /**
    * f0 -> <LETTER>
    */
   public void visit(letter n);

   /**
    * f0 -> unsigned_integer()
    */
   public void visit(radix n);

   /**
    * f0 -> ( sign() )? unscaled_real()
    *       | ( sign() )? scaled_real()
    */
   public void visit(real n);

   /**
    * f0 -> unsigned_integer() <DOT_SIGN> unsigned_integer()
    *       | unsigned_integer() <DOT_SIGN>
    *       | <DOT_SIGN> unsigned_integer()
    */
   public void visit(unscaled_real n);

   /**
    * f0 -> unscaled_real()
    * f1 -> exponent()
    */
   public void visit(scaled_real n);

   /**
    * f0 -> <EXP_E_C> integer()
    *       | <EXP_E_L> integer()
    */
   public void visit(exponent n);

   /**
    * f0 -> year_day()
    */
   public void visit(date n);

   /**
    * f0 -> <YEAR_DAY>
    */
   public void visit(year_day n);

   /**
    * f0 -> year()
    * f1 -> <MINUS_SIGN>
    * f2 -> month()
    * f3 -> <MINUS_SIGN>
    * f4 -> day()
    */
   public void visit(year_month_day n);

   /**
    * f0 -> unsigned_integer()
    */
   public void visit(year n);

   /**
    * f0 -> unsigned_integer()
    */
   public void visit(month n);

   /**
    * f0 -> unsigned_integer()
    */
   public void visit(day n);

   /**
    * f0 -> hour_min_sec() ( <Z_SIGN> )?
    *       | zoned_time()
    */
   public void visit(time n);

   /**
    * f0 -> hour_min_sec()
    */
   public void visit(local_time n);

   /**
    * f0 -> hour_min_sec()
    * f1 -> <Z_SIGN>
    */
   public void visit(utc_time n);

   /**
    * f0 -> hour_min_sec()
    * f1 -> zone_offset()
    */
   public void visit(zoned_time n);

   /**
    * f0 -> <HOUR_MIN>
    */
   public void visit(hour_min_sec n);

   /**
    * f0 -> unsigned_integer()
    */
   public void visit(hour n);

   /**
    * f0 -> unsigned_integer()
    */
   public void visit(minute n);

   /**
    * f0 -> unsigned_integer()
    *       | unscaled_real()
    */
   public void visit(second n);

   /**
    * f0 -> sign()
    * f1 -> hour()
    * f2 -> ( <COLON_SIGN> minute() )?
    */
   public void visit(zone_offset n);

   /**
    * f0 -> date()
    * f1 -> <TIME_CONSTANT>
    * f2 -> time()
    */
   public void visit(date_time n);

   /**
    * f0 -> <QUOTED_STRING>
    */
   public void visit(quoted_text n);

   /**
    * f0 -> <SQUOTE_SIGN>
    * f1 -> ( character() )*
    * f2 -> <SQUOTE_SIGN>
    */
   public void visit(quoted_symbol n);

   /**
    * f0 -> <LETTER>
    *       | <DIGIT>
    *       | <SPECIAL_CHARACTER>
    *       | <SPACING_CHARACTER>
    *       | <FORMAT_EFFECTOR>
    *       | <OTHER_CHARACTER>
    */
   public void visit(character n);

}

